package formdef.plugin.example.employee.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.*;
import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;

import formdef.plugin.example.employee.business.EmployeeHandler;
import formdef.plugin.example.employee.business.Employee;
import formdef.plugin.util.FormUtils;

/**
 * @author Hubert Rabago
 */
public class EmployeeEditAction extends Action {

    private static final Log log = LogFactory.getLog(EmployeeEditAction.class);

    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
            throws Exception {

        DynaActionForm dynaForm = (DynaActionForm) form;
        log.debug("dynaForm=" + dynaForm);

        if ((dynaForm.get("action")).equals("Add New Employee")) {
            return mapping.findForward("employee.new");
        }

        int employeeNumber = Integer.parseInt((String) dynaForm.get("number"));

        Employee employee =
                EmployeeHandler.getInstance().getEmployee(employeeNumber);
        
        if (employee == null) {
            ActionMessages errors = new ActionMessages();
            errors.add(ActionMessages.GLOBAL_MESSAGE,
                    new ActionMessage("employeeForm.number.required"));
            saveErrors(request, errors);
            return mapping.getInputForward();
        }

        dynaForm = (DynaActionForm) FormUtils.setFormValues("employeeForm", employee,
                this, mapping, request);
        
        request.getSession().setAttribute("employeeForm", dynaForm);

        return mapping.findForward("employee.edit");
    }

}
