package formdef.plugin.example.employee.web;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.*;
import org.apache.struts.validator.DynaValidatorForm;

import formdef.plugin.example.employee.business.EmployeeHandler;
import formdef.plugin.example.employee.business.Employee;
import formdef.plugin.util.FormUtils;

/**
 * Process the selected action of the user on the Edit Employee form.
 */
public class EmployeeSaveExistingAction extends Action {

    public ActionForward execute(ActionMapping mapping,
                                 ActionForm form,
                                 HttpServletRequest request,
                                 HttpServletResponse response)
            throws Exception {

        DynaValidatorForm dynaForm = (DynaValidatorForm) form;
        
        if (!isCancelled(request)) {
            Employee employee = (Employee) 
                    FormUtils.getFormValues(dynaForm, this, mapping, request);
    
            // use the add'l field in the form that's not in the business object
            String selectedObject = (String) dynaForm.get("selectedButton");
            if (selectedObject.equals("Delete")) {
                EmployeeHandler.getInstance().removeEmployee(employee.getNumber());
            } else if (selectedObject.equals("Save")) {
                EmployeeHandler.getInstance().updateEmployee(employee);
            }
        }
        
        return mapping.findForward("employee.list.redirect");
    }

}
